## percona-server-5.6 5.6.49-89.0

=== debian/changelog ===
percona-server-5.6 (5.6.49-89.0-1) unstable; urgency=medium

  * Update to new upstream release Percona Server 5.6.49-89.0-2

 -- ubuntu-cloud-user <evgeniy.patlan@percona.com>  Tue, 21 Jul 2020 16:54:01 -0400
