## percona-server-5.6 5.6.50-90.0

=== debian/changelog ===
percona-server-5.6 (5.6.50-90.0-1) unstable; urgency=medium

  * Update to new upstream release Percona Server 5.6.50-90.0-2

 -- ubuntu-cloud-user <evgeniy.patlan@percona.com>  Tue, 27 Oct 2020 12:41:28 -0400
